"use strict";
/*
 * Deepkit Framework
 * Copyright (C) 2020 Deepkit UG
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.getActions = exports.getActionParameters = exports.rpc = exports.rpcProperty = exports.rpcClass = void 0;
const type_1 = require("@deepkit/type");
class RpcController {
    constructor() {
        this.name = '';
        this.actions = new Map;
    }
}
class RpcAction {
}
class RpcClass {
    constructor() {
        this.t = new RpcController;
    }
    controller(name) {
        this.t.name = name;
    }
    addAction(name, action) {
        this.t.actions.set(name, action);
    }
}
exports.rpcClass = type_1.createClassDecoratorContext(RpcClass);
class RpcProperty {
    constructor() {
        this.t = new RpcAction;
    }
    onDecorator(target, property) {
        exports.rpcClass.addAction(property, this.t)(target);
    }
    action() {
    }
}
exports.rpcProperty = type_1.createPropertyDecoratorContext(RpcProperty);
exports.rpc = type_1.mergeDecorator(exports.rpcClass, exports.rpcProperty);
function getActionParameters(target, method) {
    return type_1.getClassSchema(target).getMethodProperties(method);
}
exports.getActionParameters = getActionParameters;
function getActions(target) {
    var _a, _b;
    return (_b = (_a = exports.rpcClass._fetch(target)) === null || _a === void 0 ? void 0 : _a.actions) !== null && _b !== void 0 ? _b : new Map;
}
exports.getActions = getActions;
//# sourceMappingURL=decorators.js.map