"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("jest-extended");
require("reflect-metadata");
const file_1 = require("../src/file");
test('file', () => {
    const files = [
        new file_1.DeepkitFile('root.txt'),
        new file_1.DeepkitFile('dir/text1.txt'),
        new file_1.DeepkitFile('dir/text2.txt'),
        new file_1.DeepkitFile('anotherone/text1.txt'),
    ];
    expect(files[0].getDirectory()).toBe('/');
    expect(files[0].inDirectory('/')).toBe(true);
    expect(files[0].inDirectory('/dir/')).toBe(false);
    expect(files[0].getName()).toBe('root.txt');
    expect(files[0].getFullPath()).toBe('/root.txt');
    expect(files[1].getDirectory()).toBe('/dir/');
    expect(files[1].inDirectory('/dir/')).toBe(true);
    expect(files[1].inDirectory('/dir')).toBe(false);
    expect(files[1].inDirectory('/')).toBe(false);
    expect(files[1].getName()).toBe('text1.txt');
    expect(files[1].getFullPath()).toBe('/dir/text1.txt');
});
//# sourceMappingURL=file.spec.js.map